diff --git a/game/client/src/main/java/net/minecraft/client/gui/ScreenSignEditor.java b/game/client/src/main/java/net/minecraft/client/gui/ScreenSignEditor.java
index 4017742cd..c9d89fa4e 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/ScreenSignEditor.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/ScreenSignEditor.java
@@ -100,7 +100,7 @@ public class ScreenSignEditor extends Screen {
             Objects.requireNonNull(this.mc.getSendQueue())
                 .addToSendQueue(
                     new PacketSignUpdate(
-                        this.entitySign.x, this.entitySign.y, this.entitySign.z,
+                        this.entitySign.tilePos.x, this.entitySign.tilePos.y, this.entitySign.tilePos.z,
                         this.entitySign.signText,
                         this.entitySign.getPicture().getId(),
                         this.entitySign.getColor().id
diff --git a/game/client/src/main/java/net/minecraft/client/gui/achievements/data/AchievementPages.java b/game/client/src/main/java/net/minecraft/client/gui/achievements/data/AchievementPages.java
index c7b8a463f..bcbcff900 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/achievements/data/AchievementPages.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/achievements/data/AchievementPages.java
@@ -25,6 +25,7 @@ public class AchievementPages {
         overworldPage.addAchievement(Achievements.BUILD_PICKAXE, 4, 2);
         overworldPage.addAchievement(Achievements.BUILD_FURNACE, 3, 4);
         overworldPage.addAchievement(Achievements.ACQUIRE_IRON, 1, 4);
+        overworldPage.addAchievement(Achievements.DOWN_THE_DRAIN, 0, 6);
         overworldPage.addAchievement(Achievements.GET_DIAMONDS, -1, 4);
         overworldPage.addAchievement(Achievements.BUILD_HOE, 1, -3);
         overworldPage.addAchievement(Achievements.MAKE_BREAD, -2, -3);
diff --git a/game/client/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/block/BlockEntryMobSpawner.java b/game/client/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/block/BlockEntryMobSpawner.java
index 5ddb23ef6..3c8c3051c 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/block/BlockEntryMobSpawner.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/block/BlockEntryMobSpawner.java
@@ -24,9 +24,9 @@ public class BlockEntryMobSpawner extends BlockEntry{
     public void onTick(World world, int meta) {
         TileEntityMobSpawner spawner = (TileEntityMobSpawner) DisplayChunk.displayTileEntity;
         spawner.yaw2 = spawner.yaw;
-        double xPos = (double) spawner.x + spawner.worldObj.rand.nextFloat();
-        double yPos = (double) spawner.y + spawner.worldObj.rand.nextFloat();
-        double zPos = (double) spawner.z + spawner.worldObj.rand.nextFloat();
+        double xPos = (double) spawner.tilePos.x + spawner.worldObj.rand.nextFloat();
+        double yPos = (double) spawner.tilePos.y + spawner.worldObj.rand.nextFloat();
+        double zPos = (double) spawner.tilePos.z + spawner.worldObj.rand.nextFloat();
         spawner.worldObj.spawnParticle("smoke", xPos, yPos, zPos, 0.0D, 0.0D, 0.0D, 0);
         spawner.worldObj.spawnParticle("flame", xPos, yPos, zPos, 0.0D, 0.0D, 0.0D, 0);
         for(spawner.yaw += 1000F / ((float)spawner.delay + 200F); spawner.yaw > 360D;)
diff --git a/game/client/src/main/java/net/minecraft/client/net/handler/PacketHandlerClient.java b/game/client/src/main/java/net/minecraft/client/net/handler/PacketHandlerClient.java
index 42ac2295b..b400c9f3c 100644
--- a/game/client/src/main/java/net/minecraft/client/net/handler/PacketHandlerClient.java
+++ b/game/client/src/main/java/net/minecraft/client/net/handler/PacketHandlerClient.java
@@ -1047,7 +1047,7 @@ public class PacketHandlerClient extends PacketHandler {
         if (existingTileEntity == null || existingTileEntity.getClass() != clazz) {
             TileEntity tileEntity = TileEntityDispatcher.createAndLoadEntity(packetTileEntityData.tag);
             if (tileEntity != null) {
-                this.mc.currentWorld.setTileEntity(tileEntity.x, tileEntity.y, tileEntity.z, tileEntity);
+                this.mc.currentWorld.setTileEntity(tileEntity.tilePos.x, tileEntity.tilePos.y, tileEntity.tilePos.z, tileEntity);
             }
         } else {
             existingTileEntity.readFromNBT(packetTileEntityData.tag);
diff --git a/game/client/src/main/java/net/minecraft/client/render/TileEntityRenderDispatcher.java b/game/client/src/main/java/net/minecraft/client/render/TileEntityRenderDispatcher.java
index b31fd88ca..84a74fbc6 100644
--- a/game/client/src/main/java/net/minecraft/client/render/TileEntityRenderDispatcher.java
+++ b/game/client/src/main/java/net/minecraft/client/render/TileEntityRenderDispatcher.java
@@ -107,13 +107,13 @@ public final class TileEntityRenderDispatcher {
             return;
         if (!renderer.isVisible(tileEntity, camera, partialTick)) return;
 
-        GLRenderer.setLightmapCoord1i(world.getLightmapCoord(tileEntity.x, tileEntity.y, tileEntity.z, 0));
+        GLRenderer.setLightmapCoord1i(world.getLightmapCoord(tileEntity.tilePos.x, tileEntity.tilePos.y, tileEntity.tilePos.z, 0));
         GLRenderer.setColor3f(1f, 1f, 1f);
         renderer.doRender(tessellator,
             tileEntity,
-            (double) tileEntity.x - renderPosX,
-            (double) tileEntity.y - renderPosY,
-            (double) tileEntity.z - renderPosZ, partialTick);
+            (double) tileEntity.tilePos.x - renderPosX,
+            (double) tileEntity.tilePos.y - renderPosY,
+            (double) tileEntity.tilePos.z - renderPosZ, partialTick);
     }
 
     public <T extends TileEntity> void renderTileEntity(final @NotNull TessellatorGeneral tessellator, final @NotNull T tileEntity, final double x, final double y, final double z, final float partialTick) {
diff --git a/game/client/src/main/java/net/minecraft/client/render/tileentity/TileEntityRendererFlag.java b/game/client/src/main/java/net/minecraft/client/render/tileentity/TileEntityRendererFlag.java
index 689925dbf..2e72c4d8b 100644
--- a/game/client/src/main/java/net/minecraft/client/render/tileentity/TileEntityRendererFlag.java
+++ b/game/client/src/main/java/net/minecraft/client/render/tileentity/TileEntityRendererFlag.java
@@ -28,7 +28,7 @@ public class TileEntityRendererFlag extends TileEntityRenderer<TileEntityFlag> {
     @Override
     public void doRender(final @NotNull TessellatorGeneral tessellator, @NotNull final TileEntityFlag tileEntity, final double x, final double y, final double z, final float partialTick) {
         final World theWorld = Minecraft.getMinecraft().currentWorld;
-        final int blockUnder = theWorld.getBlockId(tileEntity.x, tileEntity.y - 1, tileEntity.z);
+        final int blockUnder = theWorld.getBlockId(tileEntity.tilePos.x, tileEntity.tilePos.y - 1, tileEntity.tilePos.z);
         final boolean shortPole = blockUnder == Blocks.FLAG.id();
 
         final WindProvider theWind = this.mc.currentWorld.getWorldType().getWindManager();
diff --git a/game/client/src/main/java/net/minecraft/client/render/tileentity/TileEntityRendererFlowerJar.java b/game/client/src/main/java/net/minecraft/client/render/tileentity/TileEntityRendererFlowerJar.java
index 50f8675f0..ca69da086 100644
--- a/game/client/src/main/java/net/minecraft/client/render/tileentity/TileEntityRendererFlowerJar.java
+++ b/game/client/src/main/java/net/minecraft/client/render/tileentity/TileEntityRendererFlowerJar.java
@@ -26,7 +26,7 @@ public class TileEntityRendererFlowerJar extends TileEntityRenderer<TileEntityFl
         GLRenderer.enableState(State.BLEND);
         GLRenderer.setBlendFunc(BlendFactor.SRC_ALPHA, BlendFactor.ONE_MINUS_SRC_ALPHA);
         Lighting.disable();
-        BlockModelDispatcher.getInstance().getDispatch(block).renderStandalone(tessellator, tileEntity.flowerData, tileEntity.worldObj.getLightmapCoord(tileEntity.x, tileEntity.y, tileEntity.z, 0));
+        BlockModelDispatcher.getInstance().getDispatch(block).renderStandalone(tessellator, tileEntity.flowerData, tileEntity.worldObj.getLightmapCoord(tileEntity.tilePos.x, tileEntity.tilePos.y, tileEntity.tilePos.z, 0));
         Lighting.enableLight();
         GLRenderer.disableState(State.BLEND);
         GLRenderer.popFrame();
diff --git a/game/client/src/main/java/net/minecraft/client/render/tileentity/TileEntityRendererMeshGold.java b/game/client/src/main/java/net/minecraft/client/render/tileentity/TileEntityRendererMeshGold.java
index 58c4fea60..05852117a 100644
--- a/game/client/src/main/java/net/minecraft/client/render/tileentity/TileEntityRendererMeshGold.java
+++ b/game/client/src/main/java/net/minecraft/client/render/tileentity/TileEntityRendererMeshGold.java
@@ -1,6 +1,8 @@
 package net.minecraft.client.render.tileentity;
 
 import net.minecraft.client.option.GameSettings;
+import net.minecraft.client.render.RenderGlobal;
+import net.minecraft.client.render.renderer.DrawMode;
 import net.minecraft.client.render.renderer.GLRenderer;
 import net.minecraft.core.block.entity.TileEntityMeshGold;
 
@@ -9,23 +11,23 @@ import net.minecraft.client.render.item.model.ItemModelDispatcher;
 import net.minecraft.client.render.tessellator.TessellatorGeneral;
 import net.minecraft.core.util.helper.MathHelper;
 import net.minecraft.core.world.pos.TilePos;
+import org.joml.primitives.AABBd;
 
 public class TileEntityRendererMeshGold extends TileEntityRenderer<TileEntityMeshGold> {
 
     @Override
-    public void doRender(TessellatorGeneral tessellator, TileEntityMeshGold tileEntity, double x, double y, double z, float renderPartialTicks) {
+    public void doRender(TessellatorGeneral tessellator, TileEntityMeshGold tileEntity, double x, double y, double z, float partialTicks) {
         if (tileEntity.filterItem == null) return;
         GLRenderer.pushFrame();
 
-        final float bobbingOffset = MathHelper.sin((tileEntity.ticksRan + renderPartialTicks) / 10F) * 0.1F + 0.1F;
-        final float yaw = (float) Math.toDegrees(((tileEntity.ticksRan + renderPartialTicks) / 20F));
+        final float bobbingOffset = MathHelper.sin((tileEntity.ticksRan + partialTicks) / 10F) * 0.1F + 0.1F;
+        final float yaw = (float) Math.toDegrees(((tileEntity.ticksRan + partialTicks) / 20F));
 
         GLRenderer.modelM4f().translate((float) x + 0.5f, (float) y + bobbingOffset + 0.25f, (float) z + 0.5f);
 
-
         ItemModelDispatcher.getInstance().getDispatch(tileEntity.filterItem).renderItemEntity(tessellator, tileEntity.filterItem,
             GameSettings.ITEMS_3D.value, 1, tileEntity.ticksRan, yaw,
-            Minecraft.getMinecraft().currentWorld.getLightIndex(new TilePos(tileEntity.x, tileEntity.y, tileEntity.z), 0), renderPartialTicks);
+            Minecraft.getMinecraft().currentWorld.getLightIndex(new TilePos(tileEntity.tilePos.x, tileEntity.tilePos.y, tileEntity.tilePos.z), 0), partialTicks);
         GLRenderer.popFrame();
     }
 }
diff --git a/game/client/src/main/java/net/minecraft/client/render/tileentity/TileEntityRendererMobSpawner.java b/game/client/src/main/java/net/minecraft/client/render/tileentity/TileEntityRendererMobSpawner.java
index a76932b2f..b67e16baf 100644
--- a/game/client/src/main/java/net/minecraft/client/render/tileentity/TileEntityRendererMobSpawner.java
+++ b/game/client/src/main/java/net/minecraft/client/render/tileentity/TileEntityRendererMobSpawner.java
@@ -46,7 +46,7 @@ public class TileEntityRendererMobSpawner extends TileEntityRenderer<TileEntityM
             GLRenderer.modelM4f().translate(0.0F, -0.4F, 0.0F);
             GLRenderer.modelM4f().scale(f1, f1, f1);
 //            System.out.printf("X: %f, Y: %f, Z: %f\n", x, y, z);
-            entity.moveTo(mobSpawner.x, mobSpawner.y, mobSpawner.z, 0.0F, 0.0F);
+            entity.moveTo(mobSpawner.tilePos.x, mobSpawner.tilePos.y, mobSpawner.tilePos.z, 0.0F, 0.0F);
             EntityRenderer.renderShadows = false;
             EntityRendererDispatcher.instance.renderEntityWithPosYaw(tessellator, entity, 0.0D, 0.0D, 0.0D, 0.0F, partialTick);
             EntityRenderer.renderShadows = true;
diff --git a/game/client/src/main/java/net/minecraft/client/render/tileentity/TileEntityRendererMovingPiston.java b/game/client/src/main/java/net/minecraft/client/render/tileentity/TileEntityRendererMovingPiston.java
index aac3c8ada..496689bb9 100644
--- a/game/client/src/main/java/net/minecraft/client/render/tileentity/TileEntityRendererMovingPiston.java
+++ b/game/client/src/main/java/net/minecraft/client/render/tileentity/TileEntityRendererMovingPiston.java
@@ -38,14 +38,14 @@ public class TileEntityRendererMovingPiston extends TileEntityRenderer<TileEntit
             if (this.container == null || this.container.world != tileEntity.worldObj) {
                 this.container = new BlocksContainer(tileEntity.worldObj);
             }
-            TilePos tileEntPos = new TilePos(tileEntity.x, tileEntity.y, tileEntity.z);
+            TilePos tileEntPos = new TilePos(tileEntity.tilePos.x, tileEntity.tilePos.y, tileEntity.tilePos.z);
             TextureRegistry.worldAtlas.bind();
             GLRenderer.setShader(Shaders.ITEM);
             GLRenderer.setBlendFunc(BlendFactor.SRC_ALPHA, BlendFactor.ONE_MINUS_SRC_ALPHA);
             GLRenderer.enableState(State.BLEND);
             GLRenderer.disableState(State.CULL_FACE);
             tessellator.startDrawingQuads();
-            tessellator.setTranslation(((float) x - (float) tileEntity.x) + tileEntity.getXOff(partialTick), ((float) y - (float) tileEntity.y) + tileEntity.getYOff(partialTick), ((float) z - (float) tileEntity.z) + tileEntity.getZOff(partialTick));
+            tessellator.setTranslation(((float) x - (float) tileEntity.tilePos.x) + tileEntity.getXOff(partialTick), ((float) y - (float) tileEntity.tilePos.y) + tileEntity.getYOff(partialTick), ((float) z - (float) tileEntity.tilePos.z) + tileEntity.getZOff(partialTick));
             if (Block.hasLogicClass(block, BlockLogicPistonHead.class) && tileEntity.getProgress(partialTick) < 0.5F) {
                 ((BlockModelGenericPistonHead<?>) BlockModelDispatcher.getInstance().getDispatch(block)).renderPistonHeadNoCulling(tessellator, tileEntity.worldObj, tileEntity.getBlockMeta(), tileEntPos, false);
             } else if (tileEntity.isSourcePiston() && !tileEntity.isExtending()) {
@@ -55,10 +55,10 @@ public class TileEntityRendererMovingPiston extends TileEntityRenderer<TileEntit
                 } else {
                     ((BlockModelGenericPistonHead<?>) BlockModelDispatcher.getInstance().getDispatch(Blocks.PISTON_HEAD)).renderPistonHeadNoCulling(tessellator, tileEntity.worldObj, tileEntity.getBlockMeta(), tileEntPos, tileEntity.getProgress(partialTick) < 0.5F);
                 }
-                tessellator.setTranslation((float) x - (float) tileEntity.x, (float) y - (float) tileEntity.y, (float) z - (float) tileEntity.z);
+                tessellator.setTranslation((float) x - (float) tileEntity.tilePos.x, (float) y - (float) tileEntity.tilePos.y, (float) z - (float) tileEntity.tilePos.z);
                 pistonBase.renderHeadless(tessellator, tileEntity.worldObj, tileEntPos);
             } else {
-                this.container.setBlock(tileEntity.x, tileEntity.y, tileEntity.z, block.id(), tileEntity.getMovedData(), tileEntity.getMovedEntity());
+                this.container.setBlock(tileEntity.tilePos.x, tileEntity.tilePos.y, tileEntity.tilePos.z, block.id(), tileEntity.getMovedData(), tileEntity.getMovedEntity());
                 BlockModelDispatcher.getInstance().getDispatch(block).renderNoCulling(tessellator, this.container, tileEntPos);
                 this.container.setLightReferenceEntity(null);
                 this.container.clear();
diff --git a/game/client/src/main/java/net/minecraft/client/render/tileentity/TileEntityRendererSign.java b/game/client/src/main/java/net/minecraft/client/render/tileentity/TileEntityRendererSign.java
index 4d5093546..2380339f6 100644
--- a/game/client/src/main/java/net/minecraft/client/render/tileentity/TileEntityRendererSign.java
+++ b/game/client/src/main/java/net/minecraft/client/render/tileentity/TileEntityRendererSign.java
@@ -194,7 +194,7 @@ public class TileEntityRendererSign extends TileEntityRenderer<TileEntitySign> {
 
     @Override
     public boolean isVisible(@NotNull final TileEntitySign tileEntity, final @NotNull ICamera camera, final float partialTick) {
-        return camera.getFrustum().isVisible(new AABBd(tileEntity.x, tileEntity.y, tileEntity.z, tileEntity.x + 1, tileEntity.y + 1, tileEntity.z + 1), partialTick);
+        return camera.getFrustum().isVisible(new AABBd(tileEntity.tilePos.x, tileEntity.tilePos.y, tileEntity.tilePos.z, tileEntity.tilePos.x + 1, tileEntity.tilePos.y + 1, tileEntity.tilePos.z + 1), partialTick);
     }
 
     public static class BufferedTextMeshRenderer {
diff --git a/game/client/src/main/java/net/minecraft/client/render/tileentity/TileEntityRendererStatue.java b/game/client/src/main/java/net/minecraft/client/render/tileentity/TileEntityRendererStatue.java
index acddbcc65..3fb385560 100644
--- a/game/client/src/main/java/net/minecraft/client/render/tileentity/TileEntityRendererStatue.java
+++ b/game/client/src/main/java/net/minecraft/client/render/tileentity/TileEntityRendererStatue.java
@@ -75,7 +75,7 @@ public class TileEntityRendererStatue extends TileEntityRenderer<TileEntityStatu
                 renderArmor(tessellator, armorWearer, i, pose);
             }
         }
-        renderHeldItem(heldStack, Minecraft.getMinecraft().currentWorld.getLightIndex(new TilePos(statue.x, statue.y, statue.z), 0), isPigman);
+        renderHeldItem(heldStack, Minecraft.getMinecraft().currentWorld.getLightIndex(new TilePos(statue.tilePos.x, statue.tilePos.y, statue.tilePos.z), 0), isPigman);
         GLRenderer.popFrame();
 
         GLRenderer.enableState(State.CULL_FACE);
@@ -108,7 +108,7 @@ public class TileEntityRendererStatue extends TileEntityRenderer<TileEntityStatu
     @Override
     public void doRender(@NotNull final TessellatorGeneral tessellator, @NotNull final TileEntityStatue tileEntity, final double x, final double y, final double z, final float partialTick) {
         renderAt(tessellator, tileEntity, tileEntity.getHeldItem(), tileEntity.getBlockMeta(), tileEntity.getBlock(), tileEntity.getPose(), tileEntity, x, y, z);
-        renderShadow(Minecraft.getMinecraft().currentWorld, tessellator, tileEntity.x, tileEntity.y, tileEntity.z, x, y, z, 2.0f, partialTick);
+        renderShadow(Minecraft.getMinecraft().currentWorld, tessellator, tileEntity.tilePos.x, tileEntity.tilePos.y, tileEntity.tilePos.z, x, y, z, 2.0f, partialTick);
     }
 
     private boolean renderArmor(final @NotNull TessellatorGeneral tessellator, final @NotNull IArmorWearing<? super HumanArmorShape> armorWearer, final int layer, final TileEntityStatue.@NotNull Pose pose) {
diff --git a/game/core/src/main/java/net/minecraft/core/achievement/Achievements.java b/game/core/src/main/java/net/minecraft/core/achievement/Achievements.java
index f0209e5ad..e72e72249 100644
--- a/game/core/src/main/java/net/minecraft/core/achievement/Achievements.java
+++ b/game/core/src/main/java/net/minecraft/core/achievement/Achievements.java
@@ -28,6 +28,9 @@ public abstract class Achievements
     public static Achievement ACQUIRE_IRON =
         new Achievement(NamespaceID.fromPool("minecraft", "acquire_iron"), "acquireIron", Items.INGOT_IRON, BUILD_FURNACE)
             .registerAchievement();
+    public static Achievement DOWN_THE_DRAIN =
+            new Achievement(NamespaceID.fromPool("minecraft", "down_the_drain"), "downTheDrain", Blocks.MESH, ACQUIRE_IRON)
+                    .registerAchievement();
     public static Achievement GET_DIAMONDS =
         new Achievement(NamespaceID.fromPool("minecraft", "get_diamonds"), "getDiamonds", Items.DIAMOND, ACQUIRE_IRON)
             .setType(Achievement.TYPE_SPECIAL)
diff --git a/game/core/src/main/java/net/minecraft/core/achievement/stat/StatList.java b/game/core/src/main/java/net/minecraft/core/achievement/stat/StatList.java
index 37b867c95..d0d43ad62 100644
--- a/game/core/src/main/java/net/minecraft/core/achievement/stat/StatList.java
+++ b/game/core/src/main/java/net/minecraft/core/achievement/stat/StatList.java
@@ -308,6 +308,8 @@ public abstract class StatList
                         return Achievements.OPEN_GUIDEBOOK;
                     case 23:
                         return Achievements.CAUGHT_EM_ALL;
+                    case 24:
+                        return Achievements.DOWN_THE_DRAIN;
                 }
             }
 
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicFluid.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicFluid.java
index 3406d37cc..1700187a6 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicFluid.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicFluid.java
@@ -141,6 +141,11 @@ public abstract class BlockLogicFluid extends BlockLogic {
         this.fluid.animationTick(this, world, tilePos, rand);
     }
 
+    //used to detect if the water is a stream (including "flowing" source blocks), or still
+    public boolean hasFlowVector(final @NotNull WorldSource source, final @NotNull TilePosc tilePos){
+        return !Double.isNaN(getSlopeAngle(source, tilePos));
+    }
+
     public double getSlopeAngle(final @NotNull WorldSource source, final @NotNull TilePosc tilePos) {
         final Vector3dc vec = getFlow(source, tilePos);
         if (vec.x() == 0.0D && vec.z() == 0.0D) {
@@ -241,4 +246,8 @@ public abstract class BlockLogicFluid extends BlockLogic {
 
         return false;
     }
+
+    public boolean isFullBlock(@NotNull World world, TilePos tilePos){
+        return getFluidHeight(world, tilePos) == 1;
+    }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicMesh.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicMesh.java
index fe5ad1884..99ea73638 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicMesh.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicMesh.java
@@ -1,5 +1,6 @@
 package net.minecraft.core.block;
 
+import net.minecraft.core.block.entity.TileEntityMesh;
 import net.minecraft.core.block.material.Materials;
 import net.minecraft.core.entity.Entity;
 import net.minecraft.core.entity.EntityItem;
@@ -13,6 +14,7 @@ public class BlockLogicMesh extends BlockLogicTransparent
     public BlockLogicMesh(@NotNull Block<?> block)
     {
         super(block, Materials.METAL);
+        block.withEntity(TileEntityMesh::new);
     }
     
     @Override
diff --git a/game/core/src/main/java/net/minecraft/core/block/entity/TileEntity.java b/game/core/src/main/java/net/minecraft/core/block/entity/TileEntity.java
index c2ec0bd7b..698bf55f3 100644
--- a/game/core/src/main/java/net/minecraft/core/block/entity/TileEntity.java
+++ b/game/core/src/main/java/net/minecraft/core/block/entity/TileEntity.java
@@ -14,6 +14,7 @@ import net.minecraft.core.util.helper.MathHelper;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.ICarriable;
 import net.minecraft.core.world.World;
+import net.minecraft.core.world.pos.TilePos;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
 
@@ -21,9 +22,7 @@ public abstract class TileEntity implements ICarriable
 {
     public @Nullable World worldObj; // Null when loading data from nbt and null when held by entity
     public @Nullable CarriedBlock carriedBlock;
-    public int x; // TODO replace with tilePos
-    public int y;
-    public int z;
+    public TilePos tilePos = new TilePos();
     protected boolean tileEntityInvalid;
 
     public TileEntity()
@@ -42,10 +41,10 @@ public abstract class TileEntity implements ICarriable
             int id = getBlockId();
             if (id != 0 && Blocks.getBlock(id).isSignalSource()) {
                 for (Side s : Side.sides){
-                    worldObj.notifyBlocksOfNeighborChange(x + s.getOffsetX(), y + s.getOffsetY(), z + s.getOffsetZ(), getBlockId());
+                    worldObj.notifyBlocksOfNeighborChange(tilePos.x + s.getOffsetX(), tilePos.y + s.getOffsetY(), tilePos.z + s.getOffsetZ(), getBlockId());
                 }
             }
-            worldObj.updateTileEntityChunkAndSendToPlayer(x, y, z, this);
+            worldObj.updateTileEntityChunkAndSendToPlayer(tilePos.x, tilePos.y, tilePos.z, this);
         }
     }
     
@@ -58,7 +57,7 @@ public abstract class TileEntity implements ICarriable
         if (carriedBlock != null) {
             return carriedBlock.blockId;
         } else {
-            return worldObj.getBlockId(x, y, z);
+            return worldObj.getBlockId(tilePos.x, tilePos.y, tilePos.z);
         }
     }
 
@@ -66,7 +65,7 @@ public abstract class TileEntity implements ICarriable
         if (carriedBlock != null) {
             return carriedBlock.block();
         } else {
-            return worldObj.getBlock(x, y, z);
+            return worldObj.getBlock(tilePos.x, tilePos.y, tilePos.z);
         }
     }
 
@@ -74,16 +73,16 @@ public abstract class TileEntity implements ICarriable
         if (carriedBlock != null) {
             return carriedBlock.metadata;
         } else {
-            return worldObj.getBlockMetadata(x, y, z);
+            return worldObj.getBlockMetadata(tilePos.x, tilePos.y, tilePos.z);
         }
     }
 
 
     public double getDistanceFrom(double x, double y, double z)
     {
-        double dx = ((double) this.x + 0.5D) - x;
-        double dy = ((double) this.y + 0.5D) - y;
-        double dz = ((double) this.z + 0.5D) - z;
+        double dx = ((double) this.tilePos.x + 0.5D) - x;
+        double dy = ((double) this.tilePos.y + 0.5D) - y;
+        double dz = ((double) this.tilePos.z + 0.5D) - z;
         return dx * dx + dy * dy + dz * dz;
     }
 
@@ -104,9 +103,9 @@ public abstract class TileEntity implements ICarriable
 
     public final void readFromNBT(@NotNull CompoundTag compoundTag)
     {
-        x = compoundTag.getInteger("x");
-        y = compoundTag.getInteger("y");
-        z = compoundTag.getInteger("z");
+        tilePos.x = compoundTag.getInteger("x");
+        tilePos.y = compoundTag.getInteger("y");
+        tilePos.z = compoundTag.getInteger("z");
         readAdditionalData(compoundTag);
     }
 
@@ -121,9 +120,9 @@ public abstract class TileEntity implements ICarriable
         } else
         {
             compoundTag.putString("id", name.toString());
-            compoundTag.putInt("x", x);
-            compoundTag.putInt("y", y);
-            compoundTag.putInt("z", z);
+            compoundTag.putInt("x", tilePos.x);
+            compoundTag.putInt("y", tilePos.y);
+            compoundTag.putInt("z", tilePos.z);
             writeAdditionalData(compoundTag);
         }
     }
@@ -142,26 +141,26 @@ public abstract class TileEntity implements ICarriable
     @Override
     public boolean tryPlace(World world, Entity holder, int blockX, int blockY, int blockZ, Side side, double xPlaced, double yPlaced) {
         CarriedBlock carriedBlock = this.carriedBlock;
-        x = blockX + side.getOffsetX();
-        y = blockY + side.getOffsetY();
-        z = blockZ + side.getOffsetZ();
+        tilePos.x = blockX + side.getOffsetX();
+        tilePos.y = blockY + side.getOffsetY();
+        tilePos.z = blockZ + side.getOffsetZ();
 
-        Block<?> currentBlock = world.getBlock(x, y, z);
+        Block<?> currentBlock = world.getBlock(tilePos.x, tilePos.y, tilePos.z);
         if (currentBlock != null && !currentBlock.hasTag(BlockTags.PLACE_OVERWRITES)) return false;
-        world.setBlockAndMetadata(x, y, z, carriedBlock.blockId, carriedBlock.metadata);
+        world.setBlockAndMetadata(tilePos.x, tilePos.y, tilePos.z, carriedBlock.blockId, carriedBlock.metadata);
 
         worldObj = world;
         this.validate();
-        world.removeBlockTileEntity(x, y, z);
-        world.setTileEntity(x, y, z, this);
-        Block<?> b = world.getBlock(x, y, z);
+        world.removeBlockTileEntity(tilePos.x, tilePos.y, tilePos.z);
+        world.setTileEntity(tilePos.x, tilePos.y, tilePos.z, this);
+        Block<?> b = world.getBlock(tilePos.x, tilePos.y, tilePos.z);
         if (b != null && holder instanceof Mob) {
-            b.onBlockPlacedByMob(world, x, y, z, side, (Mob) holder, xPlaced, yPlaced);
+            b.onBlockPlacedByMob(world, tilePos.x, tilePos.y, tilePos.z, side, (Mob) holder, xPlaced, yPlaced);
         }
-        world.notifyBlockChange(x, y, z, carriedBlock.blockId);
+        world.notifyBlockChange(tilePos.x, tilePos.y, tilePos.z, carriedBlock.blockId);
         if (carriedBlock.blockId != 0 && Blocks.getBlock(carriedBlock.blockId).isSignalSource()) {
             for (Side s : Side.sides){
-                world.notifyBlocksOfNeighborChange(x + s.getOffsetX(), y + s.getOffsetY(), z + s.getOffsetZ(), getBlockId());
+                world.notifyBlocksOfNeighborChange(tilePos.x + s.getOffsetX(), tilePos.y + s.getOffsetY(), tilePos.z + s.getOffsetZ(), getBlockId());
             }
         }
         return true;
@@ -194,15 +193,15 @@ public abstract class TileEntity implements ICarriable
 
     @Override
     public ICarriable pickup(World world, Entity holder) {
-        Block<?> currentBlock = world.getBlock(x, y, z);
-        int currentMeta = world.getBlockMetadata(x, y, z);
-        world.removeBlockTileEntity(x, y, z);
-        world.setBlockRaw(x, y, z, 0);
-        world.notifyBlockChange(x, y, z, 0);
+        Block<?> currentBlock = world.getBlock(tilePos.x, tilePos.y, tilePos.z);
+        int currentMeta = world.getBlockMetadata(tilePos.x, tilePos.y, tilePos.z);
+        world.removeBlockTileEntity(tilePos.x, tilePos.y, tilePos.z);
+        world.setBlockRaw(tilePos.x, tilePos.y, tilePos.z, 0);
+        world.notifyBlockChange(tilePos.x, tilePos.y, tilePos.z, 0);
         int id = getBlockId();
         if (currentBlock.isSignalSource()) {
             for (Side s : Side.sides){
-                worldObj.notifyBlocksOfNeighborChange(x + s.getOffsetX(), y + s.getOffsetY(), z + s.getOffsetZ(), getBlockId());
+                worldObj.notifyBlocksOfNeighborChange(tilePos.x + s.getOffsetX(), tilePos.y + s.getOffsetY(), tilePos.z + s.getOffsetZ(), getBlockId());
             }
         }
         this.worldObj = null;
diff --git a/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityActivator.java b/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityActivator.java
index a370135b2..de011dcfe 100644
--- a/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityActivator.java
+++ b/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityActivator.java
@@ -184,11 +184,11 @@ public class TileEntityActivator extends TileEntity implements Container {
     @Override
     public boolean stillValid(@NotNull Player player)
     {
-        if(worldObj == null || worldObj.getTileEntity(x, y, z) != this)
+        if(worldObj == null || worldObj.getTileEntity(tilePos.x, tilePos.y, tilePos.z) != this)
         {
             return false;
         }
-        return player.distanceToSqr((double) x + 0.5D, (double) y + 0.5D, (double) z + 0.5D) <= 64D;
+        return player.distanceToSqr((double) tilePos.x + 0.5D, (double) tilePos.y + 0.5D, (double) tilePos.z + 0.5D) <= 64D;
     }
 
     @Override
